package com.twomen.employeemasterapp.db.employee

import com.twomen.employeemasterapp.db.BaseData
import io.realm.Realm
import io.realm.RealmObject
import io.realm.annotations.PrimaryKey
import java.io.File
import java.time.Year
import java.util.*
import java.util.Calendar.DATE
import java.util.Calendar.getInstance
import kotlin.math.sign

open class EmployeeObject(@PrimaryKey var id: Int = 0,
//                          var user: User? = null,
                          var ouId: Int = 0,
                          var supervisorID: Int = 0,
                          var ssnHash: Long = 0,
                          var title: String = "",
                          var firstname: String = "",
                          var middleName: String = "",
                          var lastname: String = "",
                          var primaryPhone: Long = 0,
                          var primaryPhoneExt: Int = 0,
                          var secondaryPhone: Long = 0,
                          var secondaryPhoneExt: Int = 0,
                          var spouseName: String = "",
                          var emergancyContact: String = "",
                          var emergancyPhone: Long = 0,
                          var driversLicense: String = "",
                          var driversLicenseState: String = "",
                          var driversLicenseIssueDate: Date = Date(0),
                          var driversLicenseExpireDate: Date = Date(0),
                          var hasChauffeurEndorsement: Boolean = false,
                          var chauffeurIssueState: String = "",
                          var chauffeurIssueDate: Date = Date(0),
                          var hasCDL: Boolean = false,
                          var cdlIssueState: String = "",
                          var cdlIssueDate: Date = Date(0),
                          var cdlExpirationDate: Date = Date(0),
                          var cdlNote: String = "",
                          var hasDOTPhysicalCard: Boolean = false,
                          var dotExaminationDate: Date = Date(),
                          var dotExpirationDate: Date = Date(),
                          var hasDOTDrugTest: Boolean = false,
                          var dotDrugTestDate: Date = Date(),
                          var birthDate: Date = Date(),
                          var hireDate: Date = Date(),
                          var criminalHistoryReport: Date = Date(),
                          var dmvReport: Date = Date(),
                          var accuracy: String = "",
                          var leaveDate: Date = Date(),
                          var leaveReason: String = "",
                          var notes: String = "",
                          var modifiedBy: String = "",
                          var modifiedDateTime: Date = Date(),
                          var quickBooksInitials: String? = null,
                          var lastSignature: Date = Date(),
                          var signatureFileName: String = "",
                          var crcTypeId: Int = 0,
                          var payId: Int = 0
//                          var activityTypes: RealmList<ActivityType> = RealmList()
) : RealmObject() {

    fun setUpObject() {
        val realm = Realm.getDefaultInstance()
        val employee1 = EmployeeObject(
                id = 1,
                ouId = 10001,
                supervisorID = 1,
                primaryPhone = 5175255555,
                primaryPhoneExt = 123,
                secondaryPhone = 5174205555,
                secondaryPhoneExt = 456,
                spouseName = "Erin",
                emergancyContact = "Erin Rempher",
                emergancyPhone = 5174205555,
                driversLicense = "R123456789",
                driversLicenseState = "Michigan",
                driversLicenseIssueDate = BaseData().setDate(2018, 0, 1),
                driversLicenseExpireDate = BaseData().setDate(2020, 0, 1),
                hasChauffeurEndorsement = true,
                chauffeurIssueState = "Michigan",
                chauffeurIssueDate = BaseData().setDate(2018, 0, 1),
                hasCDL = true,
                cdlIssueState = "Michigan",
                cdlIssueDate = BaseData().setDate(2018, 0, 1),
                cdlExpirationDate = BaseData().setDate(2020, 0, 1),
                cdlNote = "Testing",
                hasDOTPhysicalCard = true,
                dotExaminationDate = BaseData().setDate(2018, 0, 1),
                dotExpirationDate = BaseData().setDate(2020, 0, 1),
                hasDOTDrugTest = true,
                dotDrugTestDate = BaseData().setDate(2018, 0, 1),
                title = "Mr.",
                firstname = "Mike",
                middleName = "Scott",
                lastname = "Rempher",
                modifiedBy = "Joe",
                modifiedDateTime = Date(),
                quickBooksInitials = "MSR",
                birthDate = BaseData().setDate(1988, 2, 1),
                hireDate = BaseData().setDate(2018, 0, 1),
                criminalHistoryReport = BaseData().setDate(2018, 0, 1),
                dmvReport = BaseData().setDate(2018, 0, 1),
                accuracy = "High",
                leaveDate = BaseData().setDate(2018, 3, 1),
                leaveReason = "Vacation",
                notes = "Employee is a new hire looking to advance",
                lastSignature = BaseData().setDate(2018, 0, 1),
                signatureFileName = "mrempher_first_app",
                crcTypeId = 1,
                payId = 21345
        )

        val employee2 = EmployeeObject(
                id = 2,
                ouId = 10001,
                supervisorID = 1,
                primaryPhone = 5174205555,
                primaryPhoneExt = 123,
                secondaryPhone = 5175255555,
                secondaryPhoneExt = 456,
                spouseName = "Mike",
                emergancyContact = "Mike Rempher",
                emergancyPhone = 5174205555,
                driversLicense = "R123456789",
                driversLicenseState = "Michigan",
                driversLicenseIssueDate = BaseData().setDate(2018, 0, 1),
                driversLicenseExpireDate = BaseData().setDate(2020, 0, 1),
                hasChauffeurEndorsement = false,
                chauffeurIssueState = "Michigan",
                chauffeurIssueDate = BaseData().setDate(2018, 0, 1),
                hasCDL = false,
                cdlIssueState = "Michigan",
                cdlIssueDate = BaseData().setDate(2018, 0, 1),
                cdlExpirationDate = BaseData().setDate(2020, 0, 1),
                cdlNote = "Testing",
                hasDOTPhysicalCard = true,
                dotExaminationDate = BaseData().setDate(2018, 0, 1),
                dotExpirationDate = BaseData().setDate(2020, 0, 1),
                hasDOTDrugTest = false,
                dotDrugTestDate = BaseData().setDate(2018, 0, 1),
                title = "Mrs.",
                firstname = "Erin",
                middleName = "Elizabeth",
                lastname = "Rempher",
                modifiedBy = "Mike",
                modifiedDateTime = Date(),
                quickBooksInitials = "EER",
                birthDate = BaseData().setDate(1989, 2, 2),
                hireDate = BaseData().setDate(2018, 0, 1),
                criminalHistoryReport = BaseData().setDate(2018, 0, 1),
                dmvReport = BaseData().setDate(2018, 0, 1),
                accuracy = "High",
                leaveDate = BaseData().setDate(2018, 3, 1),
                leaveReason = "Vacation",
                notes = "Employee is a new hire looking to advance",
                lastSignature = BaseData().setDate(2018, 0, 1),
                signatureFileName = "mrempher_first_app",
                crcTypeId = 1,
                payId = 21345
        )
        realm.executeTransaction {
            realm.copyToRealmOrUpdate(employee1)
            realm.copyToRealmOrUpdate(employee2)
        }
    }
}